<?php
defined('TYPO3') or die();


call_user_func(
    function () {
        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'EventManagement',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'organizerList, show, new, create, edit, update, delete, duplicate, ajaxUpload, export',
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'new, create, createSimple, export',
                \Ig\IgRuckzuckevent\Controller\CategoryController::class => 'list, new, create, edit, update, delete, ajaxUpload',
                \Ig\IgRuckzuckevent\Controller\FeedbackController::class => 'organizerList, new, create, edit, update, delete',
                \Ig\IgRuckzuckevent\Controller\OrganizerController::class => 'list, new, create, edit, update, delete, ajaxUpload',
                \Ig\IgRuckzuckevent\Controller\SponsorController::class => 'list, new, create, edit, update, delete, ajaxUpload',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'organizerList, show, new, create, edit, update, delete, duplicate, ajaxUpload, export',
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'new, create, createSimple',
                \Ig\IgRuckzuckevent\Controller\CategoryController::class => 'list, new, create, edit, update, delete, ajaxUpload',
                \Ig\IgRuckzuckevent\Controller\FeedbackController::class => 'organizerList, new, create, edit, update, delete',
                \Ig\IgRuckzuckevent\Controller\OrganizerController::class => 'list, new, create, edit, update, delete, ajaxUpload',
                \Ig\IgRuckzuckevent\Controller\SponsorController::class => 'list, new, create, edit, update, delete, ajaxUpload',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'EventsInProcessing',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'eventsInProcessing, new, create, edit, update, delete, duplicate, ajaxUpload, export',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'eventsInProcessing, new, create, edit, update, delete, duplicate, ajaxUpload, export',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'EventsArchive',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'eventsArchive, new, create, edit, update, delete, duplicate, ajaxUpload, export',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'eventsArchive, new, create, edit, update, delete, duplicate, ajaxUpload, export',
            ]
        );
        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'SlugSuggest',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'slugSuggest',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'slugSuggest',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'CategoryManagement',
            [
                \Ig\IgRuckzuckevent\Controller\CategoryController::class => 'list, new, create, edit, update, delete, ajaxUpload',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\CategoryController::class => 'list, new, create, edit, update, delete, ajaxUpload',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'SponsorManagement',
            [
                \Ig\IgRuckzuckevent\Controller\SponsorController::class => 'list, new, create, edit, update, delete, ajaxUpload',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\SponsorController::class => 'list, new, create, edit, update, delete, ajaxUpload',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'FeedbackManagement',
            [
                \Ig\IgRuckzuckevent\Controller\FeedbackController::class => 'organizerList, new, create, edit, update, delete',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\FeedbackController::class => 'organizerList, new, create, edit, update, delete',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'OrganizerManagement',
            [
                \Ig\IgRuckzuckevent\Controller\OrganizerController::class => 'list, new, create, edit, update, delete, ajaxUpload',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\OrganizerController::class => 'list, new, create, edit, update, delete, ajaxUpload',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'Events',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'list',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'list',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'Resteventlist',
            [
                \Ig\IgRuckzuckevent\Controller\RestController::class => 'eventList',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\RestController::class => 'eventList',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'Resteventshow',
            [
                \Ig\IgRuckzuckevent\Controller\RestController::class => 'eventShow',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\RestController::class => 'eventShow',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'EventListFromJson',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'listJson',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'listJson',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'EventDetail',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'show',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'show',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'EventDetailFromJson',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'showJson',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'showJson',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'CurrentEvents',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'listCurrent',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'listCurrent',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'Registration',
            [
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'new, create, createSimple'
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'new, create, createSimple'
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'ThankYou',
            [
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'thankYou'
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'thankYou'
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'Feedback',
            [
                \Ig\IgRuckzuckevent\Controller\FeedbackController::class => 'list'
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\FeedbackController::class => 'list'
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'SearchForm',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'searchForm',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'searchForm',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'HtmlTitle',
            array(
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'htmlTitle',

            ),
            // non-cacheable actions
            array(
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'htmlTitle',

            )
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'Create',
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'publicNew,publicCreate,ajaxUpload,accept'
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\EventController::class => 'publicNew,publicCreate,ajaxUpload,accept'
            ]
        );




        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'EventsCalendar',
            [
                \Ig\IgRuckzuckevent\Controller\CalendarController::class => 'list,show',
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'create, loginFirst, subscribe, list, delete',
                \Ig\IgRuckzuckevent\Controller\UserController::class => 'new, create, reminder, confirmation, edit, update',

            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\CalendarController::class => 'list,show',
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'create, loginFirst, subscribe, list, delete',
                \Ig\IgRuckzuckevent\Controller\UserController::class => 'new, create, reminder, confirmation, edit, update',

            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'Management',
            [
                \Ig\IgRuckzuckevent\Controller\CalendarController::class => 'organizerList, new, create, edit, update, delete, export, list, show',
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'create, loginFirst, subscribe, list, listByEvent, delete, searchExport, exportXls',
                \Ig\IgRuckzuckevent\Controller\UserController::class => 'new, create, reminder, confirmation, edit, update, delete, list, newSubscription, createSubscription, exportXls, deleteSubscription',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\CalendarController::class => 'organizerList, new, create, edit, update, delete, export, list, show',
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'create, loginFirst, subscribe, list, listByEvent, delete, searchExport, exportXls',
                \Ig\IgRuckzuckevent\Controller\UserController::class => 'new, create, reminder, confirmation, edit, update, delete, list, newSubscription, createSubscription, exportXls, deleteSubscription',
            ]
        );
        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'ManagementStatistik',
            [
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'searchExport, exportXls',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'searchExport, exportXls',
            ]
        );
        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'ManagementUser',
            [
                \Ig\IgRuckzuckevent\Controller\UserController::class => 'list, new, create, reminder, confirmation, edit, update, delete, newSubscription, createSubscription, exportXls, deleteSubscription',
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'list, listByEvent, create, loginFirst, subscribe, delete, searchExport, exportXls',
                \Ig\IgRuckzuckevent\Controller\SubscriptionController::class => 'edit, update',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\UserController::class => 'list, new, create, reminder, confirmation, edit, update, delete, newSubscription, createSubscription, exportXls, deleteSubscription',
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'list, listByEvent, create, loginFirst, subscribe, delete, searchExport, exportXls',
                \Ig\IgRuckzuckevent\Controller\SubscriptionController::class => 'edit, update',
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'User',
            [
                \Ig\IgRuckzuckevent\Controller\UserController::class => 'show, new, create, reminder, confirmation, edit, update, passwordChange, updatePassword, delete, list',
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'list, subscribe, delete',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\UserController::class => 'show, new, create, reminder, confirmation, edit, update, passwordChange, updatePassword, delete, list',
                \Ig\IgRuckzuckevent\Controller\RegistrationController::class => 'list, subscribe, delete',
            ]
        );
        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgRuckzuckevent',
            'Payment',
            [
                \Ig\IgRuckzuckevent\Controller\SubscriptionController::class => 'payment, checkout, transaction',
            ],
            // non-cacheable actions
            [
                \Ig\IgRuckzuckevent\Controller\SubscriptionController::class => 'payment, checkout, transaction',
            ]
        );


        // wizards
        \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPageTSConfig(
        'mod {
            wizards.newContentElement.wizardItems.plugins {
                elements {
                    management {
                        iconIdentifier = ig_ruckzuckevent-plugin-management
                        title = LLL:EXT:ig_ruckzuckevent/Resources/Private/Language/locallang_db.xlf:tx_ig_ruckzuckevent_domain_model_management
                        description = LLL:EXT:ig_ruckzuckevent/Resources/Private/Language/locallang_db.xlf:tx_ig_ruckzuckevent_domain_model_management.description
                        tt_content_defValues {
                            CType = list
                            list_type = igruckzuckevent_management
                        }
                    }
                    events {
                        iconIdentifier = ig_ruckzuckevent-plugin-events
                        title = LLL:EXT:ig_ruckzuckevent/Resources/Private/Language/locallang_db.xlf:tx_ig_ruckzuckevent_domain_model_events
                        description = LLL:EXT:ig_ruckzuckevent/Resources/Private/Language/locallang_db.xlf:tx_ig_ruckzuckevent_domain_model_events.description
                        tt_content_defValues {
                            CType = list
                            list_type = igruckzuckevent_events
                        }
                    }
                    feedback {
                        iconIdentifier = ig_ruckzuckevent-plugin-feedback
                        title = LLL:EXT:ig_ruckzuckevent/Resources/Private/Language/locallang_db.xlf:tx_ig_ruckzuckevent_domain_model_feedback
                        description = LLL:EXT:ig_ruckzuckevent/Resources/Private/Language/locallang_db.xlf:tx_ig_ruckzuckevent_domain_model_feedback.description
                        tt_content_defValues {
                            CType = list
                            list_type = igruckzuckevent_feedback
                        }
                    }
                    eventsCalendar {
                        iconIdentifier = ig_ruckzuckevent-plugin-events
                        title = LLL:EXT:ig_ruckzuckevent/Resources/Private/Language/locallang_db.xlf:tx_ig_ruckzuckevent_domain_model_events
                        description = LLL:EXT:ig_ruckzuckevent/Resources/Private/Language/locallang_db.xlf:tx_ig_ruckzuckevent_domain_model_events.description
                        tt_content_defValues {
                            CType = list
                            list_type = igruckzuckevent_eventscalendar
                        }
                    }

                }
                show = *
            }
       }'
    );
        $iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Imaging\IconRegistry::class);

        $iconRegistry->registerIcon(
        'ig_ruckzuckevent-plugin-management',
        \TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
        ['source' => 'EXT:ig_ruckzuckevent/Resources/Public/Icons/user_plugin_management.svg']
    );

        $iconRegistry->registerIcon(
        'ig_ruckzuckevent-plugin-events',
        \TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
        ['source' => 'EXT:ig_ruckzuckevent/Resources/Public/Icons/user_plugin_events.svg']
    );

        $iconRegistry->registerIcon(
        'ig_ruckzuckevent-plugin-feedback',
        \TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
        ['source' => 'EXT:ig_ruckzuckevent/Resources/Public/Icons/user_plugin_feedback.svg']
    );

    $iconRegistry->registerIcon(
        'ig_ruckzuckevent-plugin-eventsInProcessing',
        \TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
        ['source' => 'EXT:ig_ruckzuckevent/Resources/Public/Icons/kurse_in_bearbeitung.svg']
    );

    $iconRegistry->registerIcon(
        'ig_ruckzuckevent-plugin-eventsArchive',
        \TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
        ['source' => 'EXT:ig_ruckzuckevent/Resources/Public/Icons/vergangene_kurse.svg']
    );
    $icons = [
        'igruckzuckevent-folder' => ['source' => 'EXT:ig_ruckzuckevent/Resources/Public/Icons/folder-module-igruckzuckevent.svg'],
    ];
    // registering icons
    $iconProviderClassName = \TYPO3\CMS\Core\Imaging\IconProvider\BitmapIconProvider::class;
    foreach ($icons as $identifier => $options) {
        $iconRegistry->registerIcon($identifier, $iconProviderClassName, $options);
    }



    $GLOBALS['TYPO3_CONF_VARS']['MAIL']['layoutRootPaths'][50] = 'EXT:ig_ruckzuckevent/Resources/Private/Email/Layouts/';
    $GLOBALS['TYPO3_CONF_VARS']['MAIL']['partialRootPaths'][50] = 'EXT:ig_ruckzuckevent/Resources/Private/Email/Partials/';
    $GLOBALS['TYPO3_CONF_VARS']['MAIL']['templateRootPaths'][50] = 'EXT:ig_ruckzuckevent/Resources/Private/Email/Templates/';
    }
);
